<script setup lang="ts">
import { reactive, ref } from "vue";
import axios from "axios";

const colors = [
  "#db5b51",
  "#269971",
  "#ddbc17",
  "#368fbb",
  "#4f56b9",
  "#e38619",
];

// const form = reactive({
//   orig: "老鼠爱大米吗",
//   cor: "老鼠喜欢大米妈",
// });

const form = reactive({
  orig: "",
  cor: "",
});

const list = ref([]);

const hasRes = ref(false);
const getPredict = () => {
  hasRes.value = false;
  axios.get(`/api/predict?orig=${form.orig}&cor=${form.cor}`).then((res) => {
    const { data } = res;
    list.value = data;
    // list.value = [...data, ...data, ...data];
    console.log(data);
    hasRes.value = true;
  });
};

const fuck = (text: string, colorIndex: number) => {
  return `<span style='color:${colors[colorIndex]}'>${text}</span>`;
};

const computedText = (type: "orig" | "cor") => {
  const val = form[type];
  let last = 0,
    res = "";
  list.value.forEach((item, index) => {
    const { orig_start, orig_end, cor_start, cor_end } = item;
    const start = type === "orig" ? orig_start : cor_start,
      end = type === "orig" ? orig_end : cor_end;
    res += val.slice(last, start);
    last = end;
    res += fuck(val.slice(start, end), index);
  });
  return res + val.slice(last);
};
</script>

<template>
  <div class="page">
    <div class="left">
      <div class="input-wrap">
        <el-input v-model="form.orig" type="textarea" :rows="8"></el-input>
        <el-input v-model="form.cor" type="textarea" :rows="8"></el-input>
      </div>
      <el-row justify="center" style="margin: 14px 0">
        <el-button type="primary" @click="getPredict">提交</el-button>
      </el-row>
    </div>

    <div class="output-wrap">
      <el-card v-if="hasRes" style="margin-bottom: 10px" shadow="never">
        <div v-html="computedText('orig')"></div>
        <div v-html="computedText('cor')"></div>
      </el-card>

      <el-card
        class="output"
        v-for="(item, index) in list"
        :key="index"
        shadow="never"
      >
        <template #header>
          <div
            :style="{
              color: colors[index],
              'font-weight': '600',
              'font-size': '18px',
            }"
          >
            编辑{{ index + 1 }}
          </div>
        </template>

        <div>编辑类型：{{ item.etype }}</div>
        <div v-if="form.orig.slice(item.orig_start, item.orig_end)">
          原文本：{{ form.orig.slice(item.orig_start, item.orig_end) }}
        </div>
        <div v-if="form.cor.slice(item.cor_start, item.cor_end)">
          新文本：{{ form.cor.slice(item.cor_start, item.cor_end) }}
        </div>
        <div>语法类型：{{ item.grammar }}</div>
      </el-card>
    </div>
  </div>
</template>

<style scoped lang="scss">
.page {
  display: flex;
  height: 100vh;
  overflow: hidden;
  & > div {
    flex: 1;
    margin: 30px;
  }
  .left {
    display: flex;
    flex-direction: column;
    // justify-content: center;
    padding-right: 30px;
    margin-right: 0;
    border-right: 1px solid #ccc;
  }
}
.input-wrap {
  div {
    font-size: 16px;
  }
  div + div {
    margin-top: 10px;
  }
}

.output-wrap {
  overflow: auto;
  // display: flex;
  // flex-direction: column;
  // justify-content: center;
}

.output {
  // padding: 10px;
  // border: 1px solid #999;
  // border-radius: 8px;
  & + .output {
    margin-top: 10px;
  }
}

:deep(.el-card__header) {
  padding: 8px 15px;
  // padding-top: 5px;
  // padding-bottom: 5px;
}
</style>
